#### CREATION OF A TABLE WITH DIAGNOSTIC IONS FOR METHYL-BRANCHED HYDROCARBONS
#### Ruth Castillo Cajas
#### 2018

### The first function creates a table with all possible combinations.

calcMethylBranched <- function(NMG=NULL,CL=NULL, RangeCL =c(20,40),calculateRI=FALSE) {
   
    if (is.null(NMG)) {
       NMG1 <- TRUE
	   NMG2 <- TRUE
       NMG3 <- TRUE
       NMG4 <- TRUE
   } else { 
		if (NMG==1) {
			NMG1 <- TRUE
			NMG2 <- FALSE
			NMG3 <- FALSE
			NMG4 <- FALSE
		}
		if (NMG == 2) {
			NMG2 <- TRUE
			NMG1 <- FALSE
			NMG3 <- FALSE
			NMG4 <- FALSE
		}
	   if (NMG == 3) {
		NMG3 <- TRUE
		NMG2 <- FALSE
		NMG1 <- FALSE
		NMG4 <- FALSE
	   }
	   if (NMG == 4) {
		NMG4 <- TRUE
		NMG2 <- FALSE
		NMG3 <- FALSE
		NMG1 <- FALSE
	   }
	print("Only One NMG selected")
   }
   ChainLengths <- seq(RangeCL[1],RangeCL[2],by=1)
	if (NMG1) { # only Monomethyl
	   
		MolWeights = seq(16+(14*RangeCL[1]),16+(14*RangeCL[2]),by=14)
		NMethylGr <- ceiling(ChainLengths/2)
		tab <- data.frame(cbind(MolWeights,ChainLengths,NMethylGr))	
		new1 <- data.frame(mat.or.vec(nr=0,nc=16))
		
			for (i in 1:length(tab[,1])){

				lNM <- tab$NMethylGr[i]
				newt <- mat.or.vec(nr=lNM-1,nc=16)

				newt[1:(lNM-1),1] <- 1
				newt[1:(lNM-1),2] <- seq(2,lNM,by=1) # MG
				newt[1:(lNM-1),16] <- tab$ChainLengths[i]
				newt[1:(lNM-1),6] <- paste(seq(2,lNM,by=1),"MeC",tab$ChainLengths[i],sep="")
				newt[1:(lNM-1),8] <- c(57,seq(57,(57+(14*(lNM-3))),by=14)) # Ion1
				newt[1:(lNM-1),9] <- c(seq(tab$MolWeights[i]-29,((tab$MolWeights[i]-29)-(14*(lNM-3))),by=-14)[1],seq(tab$MolWeights[i]-29,((tab$MolWeights[i]-29)-(14*(lNM-3))),by=-14)) # Ion2
				newt[1:(lNM-1),7] <- tab$MolWeights[i]
			
				new1 <- data.frame(rbind(new1,newt))	
			 }

		colnames(new1) <- c("NMG","MG","MG2","MG3","MG4","Compound","Mol.Weight","Ion1","Ion2","Ion3","Ion4","Ion5","Ion6","Ion7","Ion8","CL")
			
	} # closing Monomethyl
   
	if (NMG2) { # If only Dimethyl
	
		MolWeights = seq(16+(14*(RangeCL[1]+1)),16+(14*(RangeCL[2]+1)),by=14)
		NMethylGr <- ceiling(ChainLengths/2)-1
		tab <- data.frame(cbind(MolWeights,ChainLengths,NMethylGr))		

	    new2 <- data.frame(mat.or.vec(nr=0,nc=16))
	
        for (i in 1:length(tab[,1])){ # create the first table...

         	lNM <- tab$NMethylGr[i]
         	newt <- mat.or.vec(nr=lNM-1,nc=16)

			newt[1:(lNM-1),1] <- 2
    		newt[1:(lNM-1),2] <- seq(2,lNM,by=1)
			newt[1:(lNM-1),3] <- seq((lNM-1),1,by=-1) # the length of vectors
            newt[1:(lNM-1),16] <- tab$ChainLengths[i]
			newt[1:(lNM-1),8] <-  c(57,seq(57,(57+(14*(lNM-3))),by=14)) # Ion1
			newt[1:(lNM-1),9] <- c(seq(tab$MolWeights[i]-29,((tab$MolWeights[i]-29)-(14*(lNM-3))),by=-14)[1],seq(tab$MolWeights[i]-29,((tab$MolWeights[i]-29)-(14*(lNM-3))),by=-14)) # Ion2
    		newt[1:(lNM-1),7] <- tab$MolWeights[i]

  			for (j in 1:length(newt[,1]))  {

				newt2 <- mat.or.vec(nr=lNM-j,nc=16)
                newt2[1:(lNM-j),1] <- 2
				newt2[1:(lNM-j),2] <- rep(newt[j,2],(lNM-j)) # the first MG
				newt2[1:(lNM-j),3] <- seq(newt[j,2]+2,by=2,length.out=newt[j,3]) # the second MG
				newt2[1:(lNM-j),16] <- newt[j,16] # CL
				newt2[1:(lNM-j),6] <- paste(newt2[,2],",",newt2[,3],"-diMeC",tab$ChainLengths[i],sep="") # the naming
				newt2[1:(lNM-j),7] <- newt[j,7] # Mol Weights
				newt2[1:(lNM-j),8] <- newt[j,8] # Ion1
				if (j == 1) { # in case it is 2,x dimethyl
					newt2[1:(lNM-j),9] <- newt[j,9] + 14	
					newt2[1:(lNM-j),10] <- seq(newt[j,8]+28,by=28,length.out=newt[j,3])
					newt2[1:(lNM-j),11] <- seq(newt[j,9]-28,by=-28,length.out=newt[j,3])
				} else { # otherwise
					newt2[1:(lNM-j),9] <- newt[j,9]
					newt2[1:(lNM-j),10] <- seq(newt[j,8]+42,by=28,length.out=newt[j,3])
					newt2[1:(lNM-j),11] <- seq(newt[j,9]-42,by=-28,length.out=newt[j,3])
				}
		
				new2 <- data.frame(rbind(new2,newt2))
			}
        }
		colnames(new2) <-c("NMG","MG","MG2","MG3","MG4","Compound","Mol.Weight","Ion1","Ion2","Ion3","Ion4","Ion5","Ion6","Ion7","Ion8","CL")
    } # closing NMG2
	
	if (NMG3) { ### Trimethyl...
		
    	MolWeights = seq(16+(14*(RangeCL[1]+2)),16+(14*(RangeCL[2]+2)),by=14)
        NMethylGr <- ceiling(ChainLengths/2)-2
        tab <- data.frame(cbind(MolWeights,ChainLengths,NMethylGr))		

		new3 <- data.frame(mat.or.vec(nr=0,nc=16))
	
        for (i in 1:length(tab[,1])){ # starting the first combination

			lNM <- tab$NMethylGr[i]
         	newt <- mat.or.vec(nr=lNM-1,nc=16)
			newt[1:(lNM-1),1] <- 3
    		newt[1:(lNM-1),2] <- seq(2,lNM,by=1)
			newt[1:(lNM-1),3] <- seq((lNM-1),1,by=-1) # the length of vectors
            newt[1:(lNM-1),16] <- tab$ChainLengths[i]
			newt[1:(lNM-1),8] <-  c(57,seq(57,(57+(14*(lNM-3))),by=14))
			newt[1:(lNM-1),9] <- c(seq(tab$MolWeights[i]-29,((tab$MolWeights[i]-29)-(14*(lNM-3))),by=-14)[1],seq(tab$MolWeights[i]-29,((tab$MolWeights[i]-29)-(14*(lNM-3))),by=-14))
    		newt[1:(lNM-1),7] <- tab$MolWeights[i]

			for (j in 1:length(newt[,1]))  { # for the second combination

				newt2 <- mat.or.vec(nr=lNM-j,nc=16)
				newt2[1:(lNM-j),1] <- 3
				newt2[1:(lNM-j),2] <- rep(newt[j,2],(lNM-j)) # the first MG
				newt2[1:(lNM-j),3] <- seq(newt[j,2]+2,by=2,length.out=newt[j,3]) # the second MG
				newt2[1:(lNM-j),4] <- seq((lNM-j),1,by=-1) # second length
		  		newt2[1:(lNM-j),7] <- newt[j,7]
				newt2[1:(lNM-j),8] <- newt[j,8]
				newt2[1:(lNM-j),16] <- newt[j,16]	
				if (j == 1) { # in case it is 2,x dimethyl
					newt2[1:(lNM-j),9] <- newt[j,9] + 14	
					newt2[1:(lNM-j),10] <- seq(newt[j,8]+28,by=28,length.out=newt[j,3])
					newt2[1:(lNM-j),11] <- seq(newt[j,9]-28,by=-28,length.out=newt[j,3])
				} else {
					newt2[1:(lNM-j),9] <- newt[j,9]
					newt2[1:(lNM-j),10] <- seq(newt[j,8]+42,by=28,length.out=newt[j,3])
					newt2[1:(lNM-j),11] <- seq(newt[j,9]-42,by=-28,length.out=newt[j,3])
				}
				    for (k in 1:length(newt2[,1])) {
			 
						newt3 <- mat.or.vec(nr=newt2[k,4],nc=16) 
						newt3[1:(newt2[k,4]),1] <- 3
						newt3[1:(newt2[k,4]),2] <- newt2[k,2] # first MG
						newt3[1:(newt2[k,4]),3] <- newt2[k,3] # second MG
						newt3[1:(newt2[k,4]),4] <- seq(newt2[k,3]+2,by=2,length.out=newt2[k,4]) # 3rd MG
						newt3[1:(newt2[k,4]),7] <- newt2[k,7] # Mol Weight
						newt3[1:(newt2[k,4]),8] <- newt2[k,8] # First ion
						newt3[1:(newt2[k,4]),9] <- newt2[k,9] # 2nd Ion
						newt3[1:(newt2[k,4]),10] <- newt2[k,10]
						newt3[1:(newt2[k,4]),11] <- newt2[k,11]  ## previous ion combinations
						newt3[1:(newt2[k,4]),12] <- seq(newt2[k,10]+42,by=28,length.out=newt2[k,4])
						newt3[1:(newt2[k,4]),13] <- seq(newt2[k,11]-42,by=-28,length.out=newt2[k,4])
						newt3[1:(newt2[k,4]),16] <- newt2[k,16] # Chain Length
						newt3[1:(newt2[k,4]),6] <- paste(newt3[,2],",",newt3[,3],",",newt3[,4],"-triMeC",tab$ChainLengths[i],sep="")
					
						new3 <- data.frame(rbind(new3,newt3))
					} # closing k
				} # closing j
            } # closing i
		colnames(new3) <- c("NMG","MG","MG2","MG3","MG4","Compound","Mol.Weight","Ion1","Ion2","Ion3","Ion4","Ion5","Ion6","Ion7","Ion8","CL")
    } # closing NMG == 3
	
	if (NMG4) {  # For tetramethyl
	
		MolWeights = seq(16+(14*(RangeCL[1]+3)),16+(14*(RangeCL[2]+3)),by=14)
        NMethylGr <- ceiling(ChainLengths/2)-3
        tab <- data.frame(cbind(MolWeights,ChainLengths,NMethylGr))		

		new4 <- data.frame(mat.or.vec(nr=0,nc=16))
	
        for (i in 1:length(tab[,1])){

		   	lNM <- tab$NMethylGr[i]
         	newt <- mat.or.vec(nr=lNM-1,nc=16)
			newt[1:(lNM-1),1] <- 4
    		newt[1:(lNM-1),2] <- seq(2,lNM,by=1)
			newt[1:(lNM-1),3] <- seq((lNM-1),1,by=-1) # length of vector
            newt[1:(lNM-1),16] <- tab$ChainLengths[i]
			newt[1:(lNM-1),8] <-  c(57,seq(57,(57+(14*(lNM-3))),by=14))
			newt[1:(lNM-1),9] <- c(seq(tab$MolWeights[i]-29,((tab$MolWeights[i]-29)-(14*(lNM-3))),by=-14)[1],seq(tab$MolWeights[i]-29,((tab$MolWeights[i]-29)-(14*(lNM-3))),by=-14))
    		newt[1:(lNM-1),7] <- tab$MolWeights[i]

			for (j in 1:length(newt[,1]))  { # for the second combination

				newt2 <- mat.or.vec(nr=lNM-j,nc=16)
				newt2[1:(lNM-j),1] <- 4
				newt2[1:(lNM-j),2] <- rep(newt[j,2],(lNM-j)) # the first MG
				newt2[1:(lNM-j),3] <- seq(newt[j,2]+2,by=2,length.out=newt[j,3])  # the second MG
				newt2[1:(lNM-j),4] <- seq((lNM-j),1,by=-1) # length of vectors
		   	    newt2[1:(lNM-j),7] <- newt[j,7] # Mol Weights
				newt2[1:(lNM-j),8] <- newt[j,8]
				newt2[1:(lNM-j),16] <- newt[j,16]
				if (j == 1) { # in case it is 2,x dimethyl
					newt2[1:(lNM-j),9] <- newt[j,9] + 14	
					newt2[1:(lNM-j),10] <- seq(newt[j,8]+28,by=28,length.out=newt[j,3])
					newt2[1:(lNM-j),11] <- seq(newt[j,9]-28,by=-28,length.out=newt[j,3])
				} else {
					newt2[1:(lNM-j),9] <- newt[j,9]
					newt2[1:(lNM-j),10] <- seq(newt[j,8]+42,by=28,length.out=newt[j,3])
					newt2[1:(lNM-j),11] <- seq(newt[j,9]-42,by=-28,length.out=newt[j,3])
				}
						   
                for (k in 1:length(newt2[,1])) { # for the third combination
			  
					newt3 <- mat.or.vec(nr=newt2[k,4],nc=16)
					newt3[1:(newt2[k,4]),1] <- 4
					newt3[1:(newt2[k,4]),2] <- newt2[k,2]
					newt3[1:(newt2[k,4]),3] <- newt2[k,3]
					newt3[1:(newt2[k,4]),4] <- seq(newt2[k,3]+2,by=2,length.out=newt2[k,4])
					newt3[1:(newt2[k,4]),5] <- seq((newt2[k,4]),1,by=-1) # length of vectors
					newt3[1:(newt2[k,4]),7] <- newt2[k,7]
					newt3[1:(newt2[k,4]),8] <- newt2[k,8]
					newt3[1:(newt2[k,4]),9] <- newt2[k,9]
					newt3[1:(newt2[k,4]),10] <- newt2[k,10]
					newt3[1:(newt2[k,4]),11] <- newt2[k,11]  ## previous ion combinations
					newt3[1:(newt2[k,4]),12] <- seq(newt2[k,10]+42,by=28,length.out=newt2[k,4])
					newt3[1:(newt2[k,4]),13] <- seq(newt2[k,11]-42,by=-28,length.out=newt2[k,4])
					newt3[1:(newt2[k,4]),16] <- newt2[k,16]
					 		
					for (l in 1:length(newt3[,1])) { # for the fourth combination

						newt4 <- mat.or.vec(nr=newt3[l,5],nc=16)
						newt4[1:(newt3[l,5]),1] <- 4
						newt4[1:(newt3[l,5]),2] <- newt3[l,2] # MG1
						newt4[1:(newt3[l,5]),3] <- newt3[l,3] # MG2
						newt4[1:(newt3[l,5]),4] <- newt3[l,4] # MG3
						newt4[1:(newt3[l,5]),5] <- seq(newt3[l,4]+2,by=2,length.out=length(newt4[,1])) # MG4
						newt4[1:(newt3[l,5]),7] <- newt3[l,7]
						newt4[1:(newt3[l,5]),8] <- newt3[l,8]
						newt4[1:(newt3[l,5]),9] <- newt3[l,9]
						newt4[1:(newt3[l,5]),10] <- newt3[l,10]
						newt4[1:(newt3[l,5]),11] <- newt3[l,11]
						newt4[1:(newt3[l,5]),12] <- newt3[l,12]
						newt4[1:(newt3[l,5]),13] <- newt3[l,13]
						newt4[1:(newt3[l,5]),14] <- seq(newt3[l,12]+42,by=28,length.out=length(newt4[,1]))
						newt4[1:(newt3[l,5]),15] <- seq(newt3[l,13]-42,by=-28,length.out=length(newt4[,1]))
						newt4[1:(newt3[l,5]),16] <- newt3[l,16]
						newt4[1:(newt3[l,5]),6] <- paste(newt4[,2],",",newt4[,3],",",newt4[,4],",",newt4[,5],"-tetraMeC",tab$ChainLengths[i],sep="")
					#	newt4[1:(newt2[l,4]),17] <- (as.numeric(newt4[1:(newt2[l,4]),3]) - as.numeric(newt4[1:(newt2[l,4]),2]))+ (as.numeric(newt4[1:(newt2[l,4]),4]) - as.numeric(newt4[1:(newt2[l,4]),3])) +  (as.numeric(newt4[1:(newt2[l,4]),5]) - as.numeric(newt4[1:(newt2[l,4]),4]))
						
					    new4 <- data.frame(rbind(new4,newt4))
					} # closing l
				} # closing k
            } # closing j
		} # closing i
	colnames(new4) <- c("NMG","MG","MG2","MG3","MG4","Compound","Mol.Weight","Ion1","Ion2","Ion3","Ion4","Ion5","Ion6","Ion7","Ion8","CL")
	
	} # closing NMG4
 
 ## Passing the data
   if (is.null(NMG)) {
         new <- data.frame(rbind(new1,new2,new3,new4)) # the whole dataset... (for mono (299 rows) and dimethyl (2076 rows)
   } else {
		if (NMG==1) {
		new <- data.frame(new1)
	   }
	   if (NMG == 2) {
		new <- data.frame(new2)
	   }
	   if (NMG == 3) {
		 new <- data.frame(new3)
	   }
	   if (NMG == 4) {
		 new <- data.frame(new4)
	   }
	}
	
	for (i in c(1:5,7:16)){
 
	new[,i] <- as.numeric(as.character(new[,i]))
 
	}
	
	if(calculateRI) { # From Junkes et al., 2002
	
		RItable <- data.frame(mat.or.vec(nr=nrow(new),nc=24))
		names(RItable) <- c("Compound","NMG","MG1","MG2","MG3","MG4","Dif21","Dif32","Dif43","SumDif","Pos2","Pos3","CL","EqA","EqB","EqC","EqD","EqE","EqF","IE","IEopt","IEoptCor","RIcal","RIexp")
		
		calculateEquationA <- function(pos2,nmg)  {# where the insertions of the methyl branches occur
			if (pos2>0) {
				val1 <- pos2 * (0.8 + log10(0.9) + log10(1) + log10(1))
				val2 <- (nmg - pos2) * (0.8 + log10(0.9) + log10(0.9) + log10(1))
				value <- val1 + val2
			} else {
				value <- nmg * (0.8 + log10(0.9) + log10(0.9) + log10(1))
			}
			return(value)
		}
		
		calculateEquationB <- function (nmg) {# the methyl groups
			return(nmg * (1 + log10(0.8))) 
		}
		
		calculateEquationC <- function(pos2) {	# the extremes
			if (pos2 >0) {
				if (pos2 == 2) {
					value <- 2 * (1 + log10(0.8))
				} else { # pos2 ==1
					value <- (1 + log10(0.8)) + (1 + log10(0.9))
				}
			} else {
				value <- 2* (1 + log10(0.9))
			}
			return(value)
		}
		
		calculateEquationD <- function(pos2,pos3) { # next to the extremes
			if (sum(pos2,pos3) == 0) { # the condition where no methyl branche is inserted in position 2 or 3
				value <- 2 * (0.9 + log10(1) + log10(0.9)) 
			} else { # whether there are methylbranches inserted at C2 or Cn-1 and/ or position C3 or Cn-2
				
					if (pos2==2) {
						value <- 0 # there are no positions next to the extremes, because they wre the insertions of the methyl branches
						
					} else { # pos2==1 
						if (pos3 == 1) {
							value <- 0 + 0.9 + log10(1) + log10(0.8) # one is missing
						} else { # pos3 ==0
							value <- 0 + 0.9 + log10(1) + log10(0.9) # one is missing...
						}
						
					} 
				
					if (pos3==2) {
						value <- 2* (0.9 + log10(1) + log10(0.8))				
					} 
					if (pos3==1) {
						value <- (0.9 + log10(1) + log10(0.8)) + (0.9 + log10(1) + log10(0.9))
					}
					
			}
			return(value)
		}
		
		calculateEquationE <- function(pos2,pos3,nmg,sumdif) { # adjacent to the insertion of the methyl groups # this is difficult
		
			if (sumdif > 0) {
				val1 <- sumdif * (0.9 + log10(0.8) + log10(0.8))
				val2 <- (nmg - sumdif) * 2 * (0.9 + log10(0.9) + log10(0.8))
			} else {
				val1 <- 0
				val2 <- 2 * nmg * (0.9 + log10(0.9) + log10(0.8)) 
			}
			
			if (sum(pos2,pos3) == 0) { # the condition where no methyl branch is inserted in position 2 or 3
				value <- val1 + val2
			} else { # if there is some methyl-branch in the position 2 or three
				if (pos2>0  | pos3 > 0) {
				val2 <- val2 - (sum(pos2,pos3)*(0.9 + log10(0.9) + log10(0.8)))
				} 
			
				value <- val1 + val2
			}
		
			return(value)
		}
		
		calculateEquationF <- function(mg1, nmg, sumdif,CL,mgl) { # all other internal Cs	## this is not yet done
		
			if (mg1 ==3) {
				add <- 0
			} else {
				if (mg1 ==2) {
					add <- 1
				}
				if (mg1 >3 & mgl < CL-1) {
					add <- -1
				}
				if (mgl == CL-1) {
					add <- add+ 1
				}
			}
			if (nmg == 1) {
				num <- CL - (nmg *4) -2  +(add) +sumdif
			} 
			if (nmg ==2) {
				num <- CL - (nmg *4) -1 +(add) +sumdif
			}
			if (nmg ==3) {
				num <- CL - (nmg *4) +(add) +sumdif
			}
			if (nmg ==4) {
				num <- CL - (nmg *4) +1 +(add) +sumdif
			}
			if ((add == 2) | ((mg1==3) & (mgl == CL-2))  ) 
			{ num <- num +1 }
			
			value <- num * (0.9 + log10(0.9) + log10(0.9))
		
			return(value)
		}
		
		for (i in 1:nrow(new)) {
		
			RItable[i,1] <- as.character(new[i,6] )
			RItable[i,2:6] <- new[i,1:5]
			RItable[i,7] <- ifelse(RItable[i,4] -  RItable[i,3]==2,1,0)
			RItable[i,8] <- ifelse(RItable[i,5] -  RItable[i,4]==2,1,0)
			RItable[i,9] <- ifelse(RItable[i,6] -  RItable[i,5]==2,1,0)
			RItable[i,10] <- sum(RItable[i,7:9]) # sumdif
			RItable[i,13] <- new[i,16] # CL
			
			pos2 <- 0
			if(RItable[i,3] == 2) {
				pos2 <- pos2+1
			} 
			if ((RItable[i,4] >= RItable[i,13] -1) |  (RItable[i,5]  >= RItable[i,13] -1) | (RItable[i,6]  >= RItable[i,13] -1) ) {
				pos2 <- pos2+1
			}
			RItable[i,11] <- pos2 # whether there is a 2 Methyl or a n-1 Methyl 
			
			pos3 <- 0
			if(RItable[i,3] == 3) {
				pos3 <- pos3+1
			} 
			if ((RItable[i,4] == RItable[i,13] -2) |  (RItable[i,5] == RItable[i,13] -2) | (RItable[i,6]  == RItable[i,13] -2) ) {
				pos3 <- pos3+1
			}
			RItable[i,12] <- pos3 # whether there is a 3 Methyl or a n-2 Methyl 
			RItable[i,14] <- calculateEquationA(pos2=RItable[i,11],nmg=RItable[i,2])  # the positions of the insertions of the MG
			RItable[i,15] <- calculateEquationB(nmg=RItable[i,2]) # the MGs
			RItable[i,16] <- calculateEquationC(pos2=RItable[i,11])
			RItable[i,17] <- calculateEquationD(pos2=RItable[i,11],pos3=RItable[i,12])
			RItable[i,18] <- calculateEquationE(pos2=RItable[i,11],pos3=RItable[i,12],nmg=RItable[i,2],sumdif=RItable[i,10])
			mgl <- max(RItable[i,3:6]) #the last mg
			RItable[i,19] <- calculateEquationF(mg1=RItable[i,3], nmg=RItable[i,2], sumdif=RItable[i,10],CL=RItable[i,13],mgl=mgl) 
		
			RItable[i,20]	<- 	sum(RItable[i,14:19]) # IE
			
			if (RItable[i,2] == 1) {
				rem <- (log10(RItable[i,3] + 1))
			} 
			if (RItable[i,2] == 2) {
				rem <- log10(RItable[i,3] + 1) + log10(RItable[i,4] + 8)
			} 
			if (RItable[i,2] == 3) {
				rem <- log10(RItable[i,3] + 1) + log10(RItable[i,4] + 8) + log10(RItable[i,5] + 24)
			} 
			if (RItable[i,2] == 4) {
				rem <- log10(RItable[i,3] + 1) + log10(RItable[i,4] + 8) + log10(RItable[i,5] + 24)  + log10(RItable[i,6] + 14)
			} 
			RItable[i,21] <- RItable[i,20] - (rem/3) # ieopt
			RItable[i,22] <- ifelse(RItable[i,3] ==3,RItable[i,21] * 1.0057,RItable[i,21] ) # ieoptcor		
			RItable[i,23] <- round(123.1042 * RItable[i,22] -39.3059,1) 
			RItable[i,24] <- round(123.161 * RItable[i,22] -39.5251 ,1)
		}
		new <- data.frame(cbind(new,RItable[,23:24]))
		
	} else {
		print("not calculating RI")
	}
  
	
   return(new) # this is the table
}
   
# 2nd Function: Filtering

 
 justIdentifyAll <- function(data,nmg=NULL,ion1,ion2=NULL,ion3=NULL,ion4=NULL,ion5=NULL,ion6=NULL,ion7=NULL,ion8=NULL,CL=NULL,MW=NULL,RI=NULL,RIthreshold=20) {

	if (is.null(nmg)) {
		nmg=4
	} else { 
		print("Only One NMG selected")
    }
	mf <- ls(pattern = "^match.$") # doing some cleaning of the files
	rm(list=mf)
  
	ions <- c(ion1,ion2,ion3,ion4,ion5,ion6,ion7,ion8)
	lions <- length(ions)

   # it works till here, now the matching... or identification perse....
	if (nmg == 1) {
		if(lions > 2) {
			print("Error, there can only be two diagnostic ions in a monomethyl alkane") 
		} else {
		match1 <- which(data$Ion1 == ion1) 
		if (length(ion2)==1) {
        match2 <-  which(data$Ion2 == ion2)
		m <- intersect(match1,match2)
     
		toprint <- data[m,6:18] } else {
        toprint <- data[match1,6:18] }
		}
	} 
    if (nmg == 2) {
		if (lions == 1)  {
			match1 <- c(which(data$Ion1 == ion1),which(data$Ion2 == ion1),which(data$Ion3 == ion1),which(data$Ion4 == ion1))
			toprint <- data[match1,6:18]
		} else {

			for (j in 1:lions) {
				ionj <- ions[j]
				nam <- paste("match",j,sep="")
				assign(nam,c(which(data$Ion1 == ionj),which(data$Ion2 == ionj),which(data$Ion3 == ionj),which(data$Ion4 == ionj)))
			}

			matchfiles <- ls(pattern = "^match.$") # to search for the match files
			lmat <- length(matchfiles)

			if(lmat == 2) {
				finalmatch <- intersect(get(matchfiles[1]),get(matchfiles[2]))
			}
			if(lmat == 3) {
				finalmatch <- intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),get(matchfiles[3]))
			}
			if(lmat == 4) {
				finalmatch <- intersect(intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),get(matchfiles[3])),get(matchfiles[4]))
			}
			toprint <- data[finalmatch,6:18]

		}# finalizing else statement
	}  # finalizing NMG == 2

    if (nmg == 3) {
     
        for (j in 1:lions) {
            ionj <- ions[j]
			nam <- paste("match",j,sep="")
			assign(nam,c(which(data$Ion1 == ionj),which(data$Ion2 == ionj),which(data$Ion3 == ionj),
			which(data$Ion4 == ionj),which(data$Ion5 == ionj),which(data$Ion6 == ionj)))
		}
        matchfiles <- ls(pattern = "^match.$") # to search for the match files
        lmat <- length(matchfiles)
        use <- logical(lmat)

		for (i in 1:lmat) {
            if (length(get(matchfiles[i])) !=0) { use[i] <- TRUE }
		}
		matchfiles <- matchfiles[use==TRUE]
		lmat <- length(matchfiles)
        if(lmat == 2) {
			finalmatch <- intersect(get(matchfiles[1]),get(matchfiles[2]))
        }
     	if(lmat == 3) {
			finalmatch <- intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),get(matchfiles[3]))
		}
    	if(lmat == 4) {
			finalmatch <- intersect(intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),get(matchfiles[3])),get(matchfiles[4]))
  	    }
	    if(lmat == 5) {
			finalmatch <- intersect(intersect(intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),
			get(matchfiles[3])),get(matchfiles[4])),get(matchfiles[5]))
  	    }
        if(lmat == 6) {
			finalmatch <- intersect(intersect(intersect(intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),
			get(matchfiles[3])),get(matchfiles[4])),get(matchfiles[5])),get(matchfiles[6]))
  	    }
	toprint <- data[finalmatch,6:18]
    
	}  # finalizing NMG == 3

	if (nmg==4) {

		for (j in 1:lions) {
			ionj <- ions[j]
			nam <- paste("match",j,sep="")
			assign(nam,c(which(data$Ion1 == ionj),which(data$Ion2 == ionj),which(data$Ion3 == ionj),
				which(data$Ion4 == ionj),which(data$Ion5 == ionj),which(data$Ion6 == ionj),
				which(data$Ion7 == ionj),which(data$Ion8==ionj)))
	    }
		matchfiles <- ls(pattern = "^match.$") # to search for the match files
        lmat <- length(matchfiles)
        use <- logical(lmat)

		for (i in 1:lmat) {
            if (length(get(matchfiles[i])) !=0) { use[i] <- TRUE }
		}
		matchfiles <- matchfiles[use==TRUE]
		lmat <- length(matchfiles)
        if(lmat == 2) {
			finalmatch <- intersect(get(matchfiles[1]),get(matchfiles[2]))
        }
     	if(lmat == 3) {
			finalmatch <- intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),get(matchfiles[3]))
   	    }
    	if(lmat == 4) {
			finalmatch <- intersect(intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),get(matchfiles[3])),get(matchfiles[4]))
  	    }
	    if(lmat == 5) {
			finalmatch <- intersect(intersect(intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),
			get(matchfiles[3])),get(matchfiles[4])),get(matchfiles[5]))
		}
        if(lmat == 6) {
			finalmatch <- intersect(intersect(intersect(intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),
			get(matchfiles[3])),get(matchfiles[4])),get(matchfiles[5])),get(matchfiles[6]))
		}
		if(lmat == 7) {
			finalmatch <- intersect(intersect(intersect(intersect(intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),
			get(matchfiles[3])),get(matchfiles[4])),get(matchfiles[5])),get(matchfiles[6])),get(matchfiles[7]))
		}
	    if(lmat == 8) {
			finalmatch <- intersect(intersect(intersect(intersect(intersect(intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),
			get(matchfiles[3])),get(matchfiles[4])),get(matchfiles[5])),get(matchfiles[6])),get(matchfiles[7])),get(matchfiles[8]))
		}
	toprint <- data[finalmatch,6:18]
	} # finalizing NMG = 4
  
	if(length(nmg) == 0) { # so if no NMG is selected it could be anything

		for (j in 1:lions) {
			ionj <- ions[j]
			nam <- paste("match",j,sep="")
			assign(nam,c(which(data$Ion1 == ionj),which(data$Ion2 == ionj),which(data$Ion3 == ionj),
					which(data$Ion4 == ionj),which(data$Ion5 == ionj),which(data$Ion6 == ionj)))
		}
        matchfiles <- ls(pattern = "^match.$") # to search for the match files
        lmat <- length(matchfiles)
		use <- logical(lmat)
		for (i in 1:lmat) {
            if (length(get(matchfiles[i])) !=0) { use[i] <- TRUE }
		}
		matchfiles <- matchfiles[use==TRUE]
		lmat <- length(matchfiles)
        if(lmat == 2) {
			finalmatch <- intersect(get(matchfiles[1]),get(matchfiles[2]))
        }
     	if(lmat == 3) {
			finalmatch <- intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),get(matchfiles[3]))
   	    }
    	if(lmat == 4) {
			finalmatch <- intersect(intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),get(matchfiles[3])),get(matchfiles[4]))
  	    }
		if(lmat == 5) {
			finalmatch <- intersect(intersect(intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),
					get(matchfiles[3])),get(matchfiles[4])),get(matchfiles[5]))
  	    }
        if(lmat == 6) {
			finalmatch <- intersect(intersect(intersect(intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),
				get(matchfiles[3])),get(matchfiles[4])),get(matchfiles[5])),get(matchfiles[6]))
		}
		if(lmat == 7) {
			finalmatch <- intersect(intersect(intersect(intersect(intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),
				get(matchfiles[3])),get(matchfiles[4])),get(matchfiles[5])),get(matchfiles[6])),get(matchfiles[7]))
		}
	    if(lmat == 8) {
			finalmatch <- intersect(intersect(intersect(intersect(intersect(intersect(intersect(get(matchfiles[1]),get(matchfiles[2])),
				get(matchfiles[3])),get(matchfiles[4])),get(matchfiles[5])),get(matchfiles[6])),get(matchfiles[7])),get(matchfiles[8]))
		}
	toprint <- data[finalmatch,6:18]
    } # closing if nmg == NULL
	
	if(!is.null(CL)) {
        match7 <-  which(toprint$CL == CL)
	}
    if(!is.null(MW)) { # if there is a restriction on the molecular weight
		match8 <- which(toprint$Mol.Weight == MW)
	}
	if(!is.null(CL) & !is.null(MW)) {
		print("Filtering based on chain length and molecular weight")
		toprint2 <- (toprint[intersect(match7,match8),1:13])
	} else {
		if(!is.null(CL) & is.null(MW)) {
		print("Filtering based on chain length")
		toprint2 <- (toprint[match7,1:13])
		}
		if(is.null(CL) & !is.null(MW)) {
		print("Filtering based on molecular weight")
		toprint2 <- (toprint[match8,1:13])
		}
		if(is.null(CL) & is.null(MW)) {
		print("No filtering: all possible combination of ions:")
		toprint2 <-(toprint)
		}
	}
	
	if(!is.null(RI)) {
		matchRI1 <- which(toprint[,12]>= RI-RIthreshold)
		matchRI2 <- which(toprint[,12]<= RI+RIthreshold)
		matchRI <- intersect(matchRI1,matchRI2)
		
		if (length(matchRI)>0) {
		print("Filtering based on retention index")
		toprint2 <- (toprint[matchRI,1:13])
		} else {
			print("No compounds found with the ions and the retention index provided. Maybe try increasing the RI threshold")
		}
	}  else {
		print("No filtering due to retention index")
	}
    return(data.frame(toprint2))
} # closing the function

### Example

MebaAll <- calcMethylBranched(NMG=NULL,CL=NULL,RangeCL =c(20,40),calculateRI=TRUE)

MebaAll <- data.frame(rbind(meba1,meba2,meba3,meba4))
   
filepath <- "D:/somwhere/inyour/computer"
write.table(MebaAll,paste(filepath,"MebaAll.csv",sep=""),sep="\t")
 

justIdentifyAll(MebaAll,nmg=2,ion1=85,365,CL=NULL,MW=NULL,RI=NULL,RIthreshold=10)


### Only odd ions can be provided and are returned by the program: e.g., 253 instead of 252.

### Here the list of possible ions for the range of hydrocarbons between C20-C40:  57  71  85  99 113 127 141 155 169 183 197 211 225 239 253 267 281 295 309 323 337 351 365 379 393 407 421 435 449 463 477 491 505 519 533 547 561 575 589 603